/*
 * rcktldr.h --- header file for the Rocket Modem II loader
 * 
 * Written by Theodore Ts'o, 1999
 *
 */

#define READBUFSIZE 512
#define PATH_CTMLDR "/etc/ctmmdmld.rm"
#define PATH_CTMFW "/etc/ctmmdmfw.rm"

#include "mux.h"

struct code {
	char 	*name;
	size_t  length;
	unsigned char 	*data;
	unsigned long	checksum;
};

typedef struct code *code_t;

/* global variables */
extern code_t loader_code, firmware_code;
extern int debug_flag, ati_flag, progress_flag;
extern int num_ports;


/* function prototypes */

	/* code.c */
int read_code(char *name, code_t *ret_code);
void free_code(code_t code);

	/* port.c */
int port_open(mux m, char *name);
void progress_init(), progress_update(), progress_end();
