/* $Id: mux.h,v 1.1 1999/03/29 15:55:31 tytso Exp $ */

/* Copyright 1999 by the Massachusetts Institute of Technology.
 *
 * Permission to use, copy, modify, and distribute this
 * software and its documentation for any purpose and without
 * fee is hereby granted, provided that the above copyright
 * notice appear in all copies and that both that copyright
 * notice and this permission notice appear in supporting
 * documentation, and that the name of M.I.T. not be used in
 * advertising or publicity pertaining to distribution of the
 * software without specific, written prior permission.
 * M.I.T. makes no representations about the suitability of
 * this software for any purpose.  It is provided "as is"
 * without express or implied warranty.
 */

#include <sys/types.h>

#define MUX_SUCCESS		0
#define MUX_ENOMEM		1
#define MUX_EDESTRUCTION	2
#define MUX_ESELECT		3

struct timeval;
struct mux_data;
struct mux_fd_data;
struct mux_timer_data;
typedef struct mux_data *mux;
typedef struct mux_fd_data *mux_fd;
typedef struct mux_timer_data *mux_timer;
typedef void (*mux_callback)(void *arg, int status);

int mux_init(mux *mptr);
void mux_destroy(mux m);

int mux_add_input(mux m, mux_fd *mfdptr, int fd, mux_callback callback,
		  void *arg);
int mux_add_output(mux m, mux_fd *mfdptr, int fd, mux_callback callback,
		   void *arg);
int mux_add_timer(mux m, mux_timer *timerptr, struct timeval *abstime,
		  mux_callback callback, void *arg);
int mux_add_rstimer(mux m, mux_timer *timerptr, time_t offset,
		    mux_callback callback, void *arg);
void mux_cancel_fd(mux m, mux_fd mfd);
void mux_cancel_timer(mux m, mux_timer timer);

int mux_loop(mux m);
int mux_fds(mux m, fd_set *read_fds, fd_set *write_fds);
struct timeval *mux_timeout(mux m, struct timeval *maxtv, struct timeval *tv);
void mux_process(mux m, fd_set *read_fds, fd_set *write_fds);

